# `remark-code-snippets`

Remark plugin for importing snippets of source files, as code blocks, based on markers found in the file.

[![npm version](https://badge.fury.io/js/@pyroxdev%2Fremark-code-snippets.svg)](https://badge.fury.io/js/@pyroxdev%2Fremark-code-snippets)

## Installation

```sh
yarn add -D @pyroxdev/remark-code-snippets
```

## Setup

See [**Using plugins**](https://github.com/remarkjs/remark/blob/master/doc/plugins.md#using-plugins) in the official documentation.

## Usage

Adds file, start, and end options to code blocks in markdown.

See below for usage.

When a source file contains the following:

```js
console.log('This will not be included');

// @start group

console.log('This will be included');

// @end group

console.log('This will also not be included');
```

...then the following code block:

````md
```js ./say-hi.js group

```
````

...will be transformed into:

````md
```js ./say-hi.js group
console.log('This will be included');
```
````

## Options

- `baseDir`: By default, file paths will be interpreted relative to the file they are referenced from. Specify a path here to override that and then reference all files relative to a fixed point. Usually, it makes sense for the baseDir to point to some top-level `src` directory.
- `async`: By default, this plugin uses `readFileSync` to read the contents of the files. Set this to `true` if you want to use `readFile` for non-blocking IO.
- `ignoreMissingFiles`: By default, referencing a file that doesn't exist will throw an error. But in some cases, e.g. in development mode, you might want to be able to iterate quickly without failing here. Set this to true for this behaviour.

## Testing

I removed the test code since I really don't want to deal with the Jest ecosystem. Please don't bug me about it.
I only support this package for the QuiltMC Developer Wiki, I would not suggest relying on it yourself.
